searchData={"content_type":"text/markdown","items":[{"doc":"The states that this action may move to. If not specified, then any state is accepted. Use `:*` to refer to all states.","ref":"dsl-ashstatemachine.html#state_machine-transitions-transition-to","title":"AshStateMachine.state_machine.transitions.transition.to","type":"DSL"},{"doc":"The states in which this action may be called. If not specified, then any state is accepted. Use `:*` to refer to all states.","ref":"dsl-ashstatemachine.html#state_machine-transitions-transition-from","title":"AshStateMachine.state_machine.transitions.transition.from","type":"DSL"},{"doc":"The corresponding action that is invoked for the transition. Use `:*` to allow any update action to perform this transition.","ref":"dsl-ashstatemachine.html#state_machine-transitions-transition-action","title":"AshStateMachine.state_machine.transitions.transition.action","type":"DSL"},{"doc":"","ref":"dsl-ashstatemachine.html#state_machine-transitions-transition","title":"AshStateMachine.state_machine.transitions.transition","type":"DSL"},{"doc":"# Wildcards\nUse `:*` to represent \"any action\" when used in place of an action, or \"any state\" when used in place of a state.\n\nFor example:\n\n```elixir\ntransition :*, from: :*, to: :*\n```\n\nThe full list of states is derived at compile time from the transitions.\nUse the `extra_states` to express that certain types should be included\nin that list even though no transitions go to/from that state explicitly.\nThis is necessary for cases where there are states that use `:*` and no\ntransition explicitly leads to that transition.\n","ref":"dsl-ashstatemachine.html#state_machine-transitions","title":"AshStateMachine.state_machine.transitions","type":"DSL"},{"doc":"The default initial state","ref":"dsl-ashstatemachine.html#state_machine-default_initial_state","title":"AshStateMachine.state_machine.default_initial_state","type":"DSL"},{"doc":"The allowed starting states of this state machine.","ref":"dsl-ashstatemachine.html#state_machine-initial_states","title":"AshStateMachine.state_machine.initial_states","type":"DSL"},{"doc":"The attribute to store the state in.","ref":"dsl-ashstatemachine.html#state_machine-state_attribute","title":"AshStateMachine.state_machine.state_attribute","type":"DSL"},{"doc":"A list of states that may be used by transitions to/from `:*`. See the docs on wildcards for more.\n","ref":"dsl-ashstatemachine.html#state_machine-extra_states","title":"AshStateMachine.state_machine.extra_states","type":"DSL"},{"doc":"A list of states that have been deprecated but are still valid. These will still be in the possible list of states, but `:*` will not include them.\n","ref":"dsl-ashstatemachine.html#state_machine-deprecated_states","title":"AshStateMachine.state_machine.deprecated_states","type":"DSL"},{"doc":"","ref":"dsl-ashstatemachine.html#state_machine","title":"AshStateMachine.state_machine","type":"DSL"},{"doc":"Provides tools for defining and working with resource-backed state machines.","ref":"AshStateMachine.html","title":"AshStateMachine","type":"module"},{"doc":"A reusable helper which returns all possible next states for a record\n(regardless of action).","ref":"AshStateMachine.html#possible_next_states/1","title":"AshStateMachine.possible_next_states/1","type":"function"},{"doc":"A reusable helper which returns all possible next states for a record given a\nspecific action.","ref":"AshStateMachine.html#possible_next_states/2","title":"AshStateMachine.possible_next_states/2","type":"function"},{"doc":"A utility to transition the state of a changeset, honoring the rules of the resource.","ref":"AshStateMachine.html#transition_state/2","title":"AshStateMachine.transition_state/2","type":"function"},{"doc":"Introspection helpers for `AshStateMachine`","ref":"AshStateMachine.Info.html","title":"AshStateMachine.Info","type":"module"},{"doc":"","ref":"AshStateMachine.Info.html#state_machine_all_states/1","title":"AshStateMachine.Info.state_machine_all_states/1","type":"function"},{"doc":"The default initial state","ref":"AshStateMachine.Info.html#state_machine_default_initial_state/1","title":"AshStateMachine.Info.state_machine_default_initial_state/1","type":"function"},{"doc":"The default initial state","ref":"AshStateMachine.Info.html#state_machine_default_initial_state!/1","title":"AshStateMachine.Info.state_machine_default_initial_state!/1","type":"function"},{"doc":"A list of states that have been deprecated but are still valid. These will still be in the possible list of states, but `:*` will not include them.","ref":"AshStateMachine.Info.html#state_machine_deprecated_states/1","title":"AshStateMachine.Info.state_machine_deprecated_states/1","type":"function"},{"doc":"A list of states that have been deprecated but are still valid. These will still be in the possible list of states, but `:*` will not include them.","ref":"AshStateMachine.Info.html#state_machine_deprecated_states!/1","title":"AshStateMachine.Info.state_machine_deprecated_states!/1","type":"function"},{"doc":"A list of states that may be used by transitions to/from `:*`. See the docs on wildcards for more.","ref":"AshStateMachine.Info.html#state_machine_extra_states/1","title":"AshStateMachine.Info.state_machine_extra_states/1","type":"function"},{"doc":"A list of states that may be used by transitions to/from `:*`. See the docs on wildcards for more.","ref":"AshStateMachine.Info.html#state_machine_extra_states!/1","title":"AshStateMachine.Info.state_machine_extra_states!/1","type":"function"},{"doc":"The allowed starting states of this state machine.","ref":"AshStateMachine.Info.html#state_machine_initial_states/1","title":"AshStateMachine.Info.state_machine_initial_states/1","type":"function"},{"doc":"The allowed starting states of this state machine.","ref":"AshStateMachine.Info.html#state_machine_initial_states!/1","title":"AshStateMachine.Info.state_machine_initial_states!/1","type":"function"},{"doc":"state_machine DSL options\n\nReturns a map containing the and any configured or default values.","ref":"AshStateMachine.Info.html#state_machine_options/1","title":"AshStateMachine.Info.state_machine_options/1","type":"function"},{"doc":"The attribute to store the state in.","ref":"AshStateMachine.Info.html#state_machine_state_attribute/1","title":"AshStateMachine.Info.state_machine_state_attribute/1","type":"function"},{"doc":"The attribute to store the state in.","ref":"AshStateMachine.Info.html#state_machine_state_attribute!/1","title":"AshStateMachine.Info.state_machine_state_attribute!/1","type":"function"},{"doc":"state_machine.transitions DSL entities","ref":"AshStateMachine.Info.html#state_machine_transitions/1","title":"AshStateMachine.Info.state_machine_transitions/1","type":"function"},{"doc":"","ref":"AshStateMachine.Info.html#state_machine_transitions/2","title":"AshStateMachine.Info.state_machine_transitions/2","type":"function"},{"doc":"The configuration for an transition.","ref":"AshStateMachine.Transition.html","title":"AshStateMachine.Transition","type":"module"},{"doc":"","ref":"AshStateMachine.Transition.html#t:t/0","title":"AshStateMachine.Transition.t/0","type":"type"},{"doc":"Changes for working with AshStateMachine resources.","ref":"AshStateMachine.BuiltinChanges.html","title":"AshStateMachine.BuiltinChanges","type":"module"},{"doc":"Try and transition to the next state. Must be only one possible next state.","ref":"AshStateMachine.BuiltinChanges.html#next_state/0","title":"AshStateMachine.BuiltinChanges.next_state/0","type":"function"},{"doc":"Changes the state to the target state, validating the transition","ref":"AshStateMachine.BuiltinChanges.html#transition_state/1","title":"AshStateMachine.BuiltinChanges.transition_state/1","type":"function"},{"doc":"Returns a mermaid flow chart of a given state machine resource.","ref":"AshStateMachine.Charts.html","title":"AshStateMachine.Charts","type":"module"},{"doc":"","ref":"AshStateMachine.Charts.html#mermaid_flowchart/1","title":"AshStateMachine.Charts.mermaid_flowchart/1","type":"function"},{"doc":"","ref":"AshStateMachine.Charts.html#mermaid_state_diagram/1","title":"AshStateMachine.Charts.mermaid_state_diagram/1","type":"function"},{"doc":"Used when an initial state is set that is not a valid initial state","ref":"AshStateMachine.Errors.InvalidInitialState.html","title":"AshStateMachine.Errors.InvalidInitialState","type":"exception"},{"doc":"Used when a state change occurs in an action with no matching transition","ref":"AshStateMachine.Errors.NoMatchingTransition.html","title":"AshStateMachine.Errors.NoMatchingTransition","type":"exception"},{"doc":"Generates a Mermaid Flow Chart for each `Ash.Resource` with the `AshStateMachine`\nextension alongside the resource.","ref":"Mix.Tasks.AshStateMachine.GenerateFlowCharts.html","title":"mix ash_state_machine.generate_flow_charts","type":"task"},{"doc":"This mix task requires the Mermaid CLI to be installed on your system.\n\nSee https://github.com/mermaid-js/mermaid-cli","ref":"Mix.Tasks.AshStateMachine.GenerateFlowCharts.html#module-prerequisites","title":"Prerequisites - mix ash_state_machine.generate_flow_charts","type":"task"},{"doc":"* `--type` - generates a given type. Valid values are `\"state_diagram\"` and `\"flow_chart\"`. Defaults to `\"state_diagram\"`.\n  * `--only` - only generates the given Flow file\n  * `--format` - Can be set to one of either:\n    * `plain` - Prints just the mermaid output as text. This is the default.\n    * `md` - Prints the mermaid diagram in a markdown code block.\n    * `svg` - Generates an SVG\n    * `pdf` - Generates a PDF\n    * `png` - Generates a PNG","ref":"Mix.Tasks.AshStateMachine.GenerateFlowCharts.html#module-command-line-options","title":"Command line options - mix ash_state_machine.generate_flow_charts","type":"task"},{"doc":"","ref":"Mix.Tasks.AshStateMachine.GenerateFlowCharts.html#run/1","title":"Mix.Tasks.AshStateMachine.GenerateFlowCharts.run/1","type":"function"},{"doc":"# Getting Started with State Machines","ref":"get-started-with-state-machines.html","title":"Getting Started with State Machines","type":"extras"},{"doc":"If you haven't already, read the [Ash Getting Started Guide](https://hexdocs.pm/ash/get-started.html), and familiarize yourself with Ash and Ash resources.","ref":"get-started-with-state-machines.html#get-familiar-with-ash-resources","title":"Get familiar with Ash resources - Getting Started with State Machines","type":"extras"},{"doc":"```elixir\ndef deps()\n  [\n    ...\n    {:ash_state_machine, \"~> 0.2.2\"}\n  ]\nend\n```","ref":"get-started-with-state-machines.html#bring-in-the-ash_state_machine-dependency","title":"Bring in the ash_state_machine dependency - Getting Started with State Machines","type":"extras"},{"doc":"The concept of a state machine (in this case a \"Finite State Machine\"), essentially involves a single `state`, with specified transitions between states. For example, you might have an order state machine with states `[:pending, :on_its_way, :delivered]`. However, you can't go from `:pending` to `:delivered` (probably), and so you want to only allow certain transitions in certain circumstances, i.e `:pending -> :on_its_way -> :delivered`.\n\nThis extension's goal is to help you write clear and clean state machines, with all of the extensibility and power of Ash resources and actions.","ref":"get-started-with-state-machines.html#making-a-resource-into-a-state-machine","title":"Making a resource into a state machine - Getting Started with State Machines","type":"extras"},{"doc":"```elixir\ndefmodule Order do\n  # leaving out data layer configuration for brevity\n  use Ash.Resource,\n    extensions: [AshStateMachine]\n\n  state_machine do\n    initial_states [:pending]\n    default_initial_state :pending\n\n    transitions do\n      transition :confirm, from: :pending, to: :confirmed\n      transition :begin_delivery, from: :confirmed, to: :on_its_way\n      transition :package_arrived, from: :on_its_way, to: :arrived\n      transition :error, from: [:pending, :confirmed, :on_its_way], to: :error\n    end\n  end\n\n  actions do\n    # create sets the state\n    defaults [:create, :read]\n\n    update :confirm do\n      # accept [...]\n      # you can change other attributes\n      # or do anything else an action can normally do\n      # this transition will be validated according to\n      # the state machine rules above\n      change transition_state(:confirmed)\n    end\n\n    update :begin_delivery do\n      # accept [...]\n      change transition_state(:on_its_way)\n    end\n\n    update :package_arrived do\n      # accept [...]\n      change transition_state(:arrived)\n    end\n\n    update :error do\n      accept [:error_state, :error]\n      change transition_state(:error)\n    end\n  end\n\n  changes do\n    # any failures should be captured and transitioned to the error state\n    change after_transaction(fn\n              changeset, {:ok, result} ->\n                {:ok, result}\n\n              changeset, {:error, error} ->\n                message = Exception.message(error)\n\n                changeset.data\n                |> Ash.Changeset.for_update(:error, %{\n                  message: message,\n                  error_state: changeset.data.state\n                })\n                |> Api.update()\n            end),\n            on: [:update]\n  end\n\n  attributes do\n    uuid_primary_key :id\n    # ...attributes like address/delivery options would go here\n    attribute :error, :string\n    attribute :error_state, :string\n    # :state attribute is added for you by `state_machine`\n    # however, you can add it yourself, and you will be guided by\n    # compile errors on what states need to be allowed by your type.\n  end\nend\n```","ref":"get-started-with-state-machines.html#a-basic-state-machine","title":"A basic state machine - Getting Started with State Machines","type":"extras"},{"doc":"run `mix ash_state_machine.generate_flow_charts` to generate flow charts for your resources. See the task documentation for more. Here is a chart generated from the example above:\n\n```mermaid\nstateDiagram-v2\npending --> confirmed: confirm\nconfirmed --> on_its_way: begin_delivery\non_its_way --> arrived: package_arrived\non_its_way --> error: error\nconfirmed --> error: error\npending --> error: error\n```","ref":"get-started-with-state-machines.html#generating-flow-charts","title":"Generating Flow Charts - Getting Started with State Machines","type":"extras"},{"doc":"- Check out the [DSL documentation](dsl-ashstatemachine.html)\n- Check out the `AshStateMachine` module docs.","ref":"get-started-with-state-machines.html#learning-more","title":"Learning more - Getting Started with State Machines","type":"extras"},{"doc":"<!--\nThis file was generated by Spark. Do not edit it by hand.\n-->\n# DSL: AshStateMachine\n\nProvides tools for defining and working with resource-backed state machines.","ref":"dsl-ashstatemachine.html","title":"DSL: AshStateMachine","type":"extras"},{"doc":"#","ref":"dsl-ashstatemachine.html#state_machine","title":"state_machine - DSL: AshStateMachine","type":"extras"},{"doc":"* [transitions](#state_machine-transitions)\n   * transition\n\n\n\n\n\n#","ref":"dsl-ashstatemachine.html#nested-dsls","title":"Nested DSLs - DSL: AshStateMachine","type":"extras"},{"doc":"| Name | Type | Default | Docs |\n|------|------|---------|------|\n| [`initial_states`](#state_machine-initial_states){: #state_machine-initial_states .spark-required} | `list(atom)` |  | The allowed starting states of this state machine. |\n| [`deprecated_states`](#state_machine-deprecated_states){: #state_machine-deprecated_states } | `list(atom)` | `[]` | A list of states that have been deprecated but are still valid. These will still be in the possible list of states, but `:*` will not include them. |\n| [`extra_states`](#state_machine-extra_states){: #state_machine-extra_states } | `list(atom)` | `[]` | A list of states that may be used by transitions to/from `:*`. See the docs on wildcards for more. |\n| [`state_attribute`](#state_machine-state_attribute){: #state_machine-state_attribute } | `atom` | `:state` | The attribute to store the state in. |\n| [`default_initial_state`](#state_machine-default_initial_state){: #state_machine-default_initial_state } | `atom` |  | The default initial state |","ref":"dsl-ashstatemachine.html#options","title":"Options - DSL: AshStateMachine","type":"extras"},{"doc":"#","ref":"dsl-ashstatemachine.html#state_machine-transitions","title":"state_machine.transitions - DSL: AshStateMachine","type":"extras"},{"doc":"Use `:*` to represent \"any action\" when used in place of an action, or \"any state\" when used in place of a state.\n\nFor example:\n\n```elixir\ntransition :*, from: :*, to: :*\n```\n\nThe full list of states is derived at compile time from the transitions.\nUse the `extra_states` to express that certain types should be included\nin that list even though no transitions go to/from that state explicitly.\nThis is necessary for cases where there are states that use `:*` and no\ntransition explicitly leads to that transition.\n\n\n#","ref":"dsl-ashstatemachine.html#wildcards","title":"Wildcards - DSL: AshStateMachine","type":"extras"},{"doc":"* [transition](#state_machine-transitions-transition)","ref":"dsl-ashstatemachine.html#nested-dsls","title":"Nested DSLs - DSL: AshStateMachine","type":"extras"},{"doc":"```elixir\ntransition action\n```\n\n\n\n\n\n\n\n\n#","ref":"dsl-ashstatemachine.html#state_machine-transitions-transition","title":"state_machine.transitions.transition - DSL: AshStateMachine","type":"extras"},{"doc":"| Name | Type | Default | Docs |\n|------|------|---------|------|\n| [`action`](#state_machine-transitions-transition-action){: #state_machine-transitions-transition-action .spark-required} | `atom` |  | The corresponding action that is invoked for the transition. Use `:*` to allow any update action to perform this transition. |\n#","ref":"dsl-ashstatemachine.html#arguments","title":"Arguments - DSL: AshStateMachine","type":"extras"},{"doc":"| Name | Type | Default | Docs |\n|------|------|---------|------|\n| [`from`](#state_machine-transitions-transition-from){: #state_machine-transitions-transition-from .spark-required} | `list(atom) \\| atom` |  | The states in which this action may be called. If not specified, then any state is accepted. Use `:*` to refer to all states. |\n| [`to`](#state_machine-transitions-transition-to){: #state_machine-transitions-transition-to .spark-required} | `list(atom) \\| atom` |  | The states that this action may move to. If not specified, then any state is accepted. Use `:*` to refer to all states. |\n\n\n\n\n\n#","ref":"dsl-ashstatemachine.html#options","title":"Options - DSL: AshStateMachine","type":"extras"},{"doc":"Target: `AshStateMachine.Transition`\n\n\n\n\n\n\n\n .spark-required::after { content: \"*\"; color: red !important; }","ref":"dsl-ashstatemachine.html#introspection","title":"Introspection - DSL: AshStateMachine","type":"extras"}]}